<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <b-breadcrumb :items="items"></b-breadcrumb>    
            <!-- Mask -->
        </base-header>
        <div class="container-fluid mt--7">
            <div class="row">
                <div class="col">
                    <div class="card shadow">
                        <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col">
                            <h3 class="mb-0">
                                {{title}}
                            </h3>
                            <select name="list-app" v-model="listApp" class="custom-select d-block w-100" @change="getAppID()">
                                <option v-for="app in appData" :key="app.app_id" :value="app.app_id">{{app.app_name}}</option>
                            </select>
                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                            </div>
                            <div class="col text-right">
                                <button class="btn btn-lg btn-primary" @click="showCreate = true">Create Hotel</button>
                            </div>
                            <div>
                                <modal :show="showCreate" @close="showCreate = false">
                                    <template slot="header">
                                        <h5 class="modal-title">Create</h5>
                                    </template>
                                    <div>
                                        <div class="col-lg-12">
                                            <base-input alternative=""
                                                        label="Hotel name"
                                                        placeholder="Hotel name"
                                                        input-classes="form-control-alternative"
                                                        v-model="hotel_name"
                                            />
                                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                                        </div>
                                    </div>
                                    <template slot="footer">
                                            <base-button type="secondary" @click="showCreate = false">Close</base-button>
                                            <base-button type="primary" @click="checkData">Create</base-button>
                                    </template>
                                </modal>
                            </div>
                        </div>
                        </div>

                        <div class="table-responsive">
                        <table class="table align-items-center table-flush text-center">
                            <tr>
                                <th>No.</th>
                                <th>Hotel name</th>
                                <th>Manage</th>
                            </tr>

                            <tr v-for="(hotel,index) in hotelData" :key="hotel.hotel_id" :class="{editing: hotel == dataEdit}" v-cloak>
                            <td>{{index+1}}</td>
                            <td class="budget">
                                <div class="view">
                                <span>{{hotel.hotel_name}}</span>
                                <small @click="goBuiding(hotel.hotel_id)"><router-link class="text-blue" to="#"> setting buiding</router-link></small>
                                </div>
                                <div class="edit">
                                <base-input alternative=""
                                                        placeholder="App name"
                                                        input-classes="form-control-alternative"
                                                        v-model="hotel.hotel_name"
                                />
                                </div>
                            </td>
                            <td>
                                <div class="view">
                                    <span @click="editData(hotel)"><router-link class="text-primary" to="#"><i class="fas fa-pen"></i> Edit</router-link></span> |  
                                    <span @click="del(hotel)"><router-link class="text-danger" to="#"><i class="far fa-trash-alt"></i> Delete</router-link></span>
                                </div>
                                <div class="edit">
                                    <span @click="saveEdit(hotel)"><router-link class="text-success" to="#"><i class="fas fa-save"></i> Save</router-link></span> |  
                                    <span @click="dataEdit = null"><router-link class="text-default" to="#"><i class="far fa-window-close"></i> Cancel</router-link></span>
                                </div>
                            </td>

                            </tr>

                        </table>
                        </div>
                    </div>
                </div>
            </div>
    </div>
</div>
</template>
<script>

  export default {
    name: 'hotel-name',
    data() {
      return {
        title: 'Hotel name',
        appData : [],
        hotelData : [],
        message : '',
        error :'',
        hotel_name : '',
        showCreate : false,
        dataEdit : null,
        listApp : '',
        items: [
          {
            text: 'Company',
            to: '/topic'
          },
          {
            text: 'App',
            to: '/app'
          },
          {
            text: 'Hotel',
            active: true
          }
        ]
      }
    },
    created() {
        this.getDataApp()
        this.getDataHotel()
    },
    methods: {
        getDataApp(){
            this.error = ''
            this.$http.get('/manage/app')
            .then(response => {
                if(!response.data.message){
                    this.appData = response.data
                    if(localStorage.app_id === ''){
                        this.listApp = response.data[0].app_id
                        localStorage.app_id = response.data[0].app_id
                    }else{
                        this.listApp = localStorage.app_id
                    }
                }else{
                    this.message = response.data.message
                }
          })
        },
        getDataHotel(){
            this.error = ''
            this.$http.get('/manage/hotel/'+localStorage.user_id+'/'+ localStorage.app_id)
            .then(response => {
                if(!response.data.message){
                    this.hotelData = response.data
                }else{
                    this.message = response.data.message
                    this.hotelData = []
                }
          })
        },
        checkData(){
            if(this.hotel_name === ''){
                this.error = 'Please enter hotel name'
            }else{
                this.sendCreate()
            }
        },
        sendCreate(){
            this.$http.post('/manage/hotel/create',{
                user_id : localStorage.user_id,
                app_id : localStorage.app_id,
                hotel_name : this.hotel_name
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Created!",
                    icon: "success",
                    timer: 3000
                })
                this.getDataHotel()
                this.showCreate = false
                this.hotel_name = ''
                this.error = ''
              }else if(response.data.message === 'cant_create'){
                  this.error = 'Can not use this hotel name !!'
              }
          })
          .catch(() => this.checkCreateHotel())
        },
        checkCreateHotel(){
            this.error = 'Create failed!!'
        },
        editData(hotel){
            this.dataEdit = hotel
        },
        saveEdit(hotel){
            this.$swal({
                    title: "Confirm edit hotel name?",
                    icon: "warning",
                    buttons: ['cancel','confirm']
                })
                .then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/hotel/edit',{
                            user_id : localStorage.user_id,
                            hotel_name : hotel.hotel_name,
                            hotel_id : hotel.hotel_id,
                            app_id : localStorage.app_id
                        })
                        .then(response => {
                            if(response.data.message === 'no_hotel'){
                                this.checkEditHotel()
                            }else if(response.data.message === 'success'){
                                this.$swal({
                                title: "Edited!",
                                icon: "success",
                                timer: 3000
                                })
                                this.getDataHotel()
                            }
                        })
                        .catch(() => this.checkEditHotel())
                    }
                })
        },
        del(hotel){
                this.$swal({
                    title: "Confirm delete hotel name!!",
                    icon: "warning",
                    buttons: ['cancel','confirm'],
                    dangerMode: true
                }).then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/hotel/del',{
                            user_id : localStorage.user_id,
                            hotel_id : hotel.hotel_id,
                            app_id : localStorage.app_id
                        })
                        .then(response => {
                            if(response.data.message === 'no_hotel'){
                                this.error = 'Delete failed!!'
                            }else if(response.data.message === 'success'){
                                this.$swal({
                                title: "Deleted!",
                                icon: "success",
                                timer: 3000
                                })
                            }
                            this.getDataHotel()
                        })
                        .catch(() => this.error = 'Delete failed!!' )
                    }
                })
        },
        checkEditHotel(){
            this.error = 'Edit failed!!'
        },
        getAppID(){
            localStorage.app_id = this.listApp
            this.getDataHotel()
        },
        goBuiding(hotel_id){
            localStorage.hotel_id = hotel_id
            this.$router.push('/buiding')
        }
    },
  };
</script>
<style scoped>
[v-cloak] {
      display: none;
    }
    .edit {
      display: none;
    }
    .editing .edit {
      display: block
    }
    .editing .view {
      display: none;
    }
</style>